/**
 * angular-permission
 * Route permission and access control as simple as it can get
 * @version v2.3.0 - 2016-03-30
 * @link http://www.rafaelvidaurre.com
 * @author Rafael Vidaurre <narzerus@gmail.com>, Blazej Krysiak <blazej.krysiak@gmail.com>
 * @license MIT License, http://www.opensource.org/licenses/MIT
 */

!function(){"use strict";var a=angular.module("permission",["ui.router"]);a.config(["$stateProvider",function(a){a.decorator("parent",function(a,b){return a.self.$$state=function(){return a},b(a)})}]),a.run(["$rootScope","$state","$q","$location","Authorization","PermissionMap",function(a,b,c,d,e,f){a.$on("$stateChangeStart",function(c,g,h,i,j,k){function l(a){return angular.isDefined(a.data)&&angular.isDefined(a.data.permissions)}function m(a){angular.extend(g,{$$isAuthorizationFinished:a})}function n(){return g.$$isAuthorizationFinished}function o(){return u()||t()}function p(){var a=new f,c=b.get(g.name).$$state().path.slice().reverse();return c.forEach(function(b){l(b)&&a.extendPermissionMap(new f(b.data.permissions))}),a}function q(a){e.authorize(a,h).then(function(){r()})["catch"](function(b){s(a,b)})["finally"](function(){m(!1)})}function r(){a.$broadcast("$stateChangePermissionAccepted",g,h,k),d.replace(),b.go(g.name,h,{notify:!1}).then(function(){a.$broadcast("$stateChangeSuccess",g,h,i,j)})}function s(c,d){a.$broadcast("$stateChangePermissionDenied",g,h,k),c.resolveRedirectState(d).then(function(a){b.go(a.state,a.params,a.options)})}function t(){return a.$broadcast("$stateChangeStart",g,h,i,j,k).defaultPrevented}function u(){return a.$broadcast("$stateChangePermissionStart",g,h,k).defaultPrevented}if(!n()&&(c.preventDefault(),m(!0),!o())){a.$broadcast("$stateChangePermissionStart",g,h,k);var v=p();q(v)}})}])}(),function(){"use strict";angular.module("permission").decorator("$q",["$delegate",function(a){function b(b){var c=a.defer(),d=0,e=angular.isArray(b)?[]:{};return angular.forEach(b,function(b,f){d++,a.when(b).then(function(a){e.hasOwnProperty(f)||c.resolve(a)})["catch"](function(a){e.hasOwnProperty(f)||(e[f]=a,--d||c.reject(a))})}),0===d&&c.reject(e),c.promise}return a.only=b,a}])}(),function(){"use strict";angular.module("permission").factory("PermissionMap",["$q",function(a){function b(a,b,c,d){a=a||{},this.only=e(a.only,b,c,d),this.except=e(a.except,b,c,d),this.redirectTo=a.redirectTo}function c(b,c){return a.when(b.call(null,c)).then(function(a){if(angular.isString(a))return{state:a};if(angular.isObject(a))return a;throw new TypeError('When used "redirectTo" as function, returned value must be string or object')})}function d(b,d){if(!angular.isDefined(b["default"]))throw new ReferenceError('When used "redirectTo" as object, property "default" must be defined');var e=b[d];return angular.isDefined(e)||(e=b["default"]),angular.isFunction(e)?c(e,d):angular.isObject(e)?a.resolve(e):angular.isString(e)?a.resolve({state:e}):void 0}function e(a,b,c,d){return angular.isString(a)?[a]:angular.isArray(a)?a:angular.isFunction(a)?a.call(null,b,c,d):[]}return b.prototype.extendPermissionMap=function(a){a.only.length&&(this.only=this.only.concat([a.only])),a.except.length&&(this.except=this.except.concat([a.except])),this.redirectTo=a.redirectTo},b.prototype.resolveRedirectState=function(b){return angular.isFunction(this.redirectTo)?c(this.redirectTo,b):angular.isObject(this.redirectTo)?d(this.redirectTo,b):angular.isString(this.redirectTo)?a.resolve({state:this.redirectTo}):a.reject(null)},b}])}(),function(){"use strict";angular.module("permission").factory("Permission",["$q",function(a){function b(a,b){d(a,b),this.permissionName=a,this.validationFunction=b}function c(b,c){var d=a.defer();return b?d.resolve(c):d.reject(c),d.promise}function d(a,b){if(!angular.isString(a))throw new TypeError('Parameter "permissionName" name must be String');if(!angular.isFunction(b))throw new TypeError('Parameter "validationFunction" must be Function')}return b.prototype.validatePermission=function(a){var b=this.validationFunction.call(null,a,this.permissionName);return angular.isFunction(b.then)||(b=c(b,this.permissionName)),b},b}])}(),function(){"use strict";angular.module("permission").factory("Role",["$q","PermissionStore",function(a,b){function c(a,c,d){e(a,c,d),this.roleName=a,this.permissionNames=c||[],this.validationFunction=d,d&&b.defineManyPermissions(c,d)}function d(b,c){var d=a.defer();return b?d.resolve(c):d.reject(c),d.promise}function e(a,b,c){if(!angular.isString(a))throw new TypeError('Parameter "roleName" name must be String');if(!angular.isArray(b))throw new TypeError('Parameter "permissionNames" must be Array');if(!b.length&&!angular.isFunction(c))throw new TypeError('Parameter "validationFunction" must be provided for empty "permissionNames" array')}return c.prototype.validateRole=function(c){if(this.permissionNames.length){var e=this.permissionNames.map(function(e){if(b.hasPermissionDefinition(e)){var f=b.getPermissionDefinition(e),g=f.validationFunction.call(null,c,f.permissionName);return angular.isFunction(g.then)||(g=d(g)),g}return a.reject(null)});return a.all(e)}var f=this.validationFunction.call(null,c,this.roleName);return angular.isFunction(f.then)||(f=d(f,this.roleName)),a.resolve(f)},c}])}(),function(){"use strict";angular.module("permission").service("PermissionStore",["Permission",function(a){function b(b,c){i[b]=new a(b,c)}function c(a,c){if(!angular.isArray(a))throw new TypeError('Parameter "permissionNames" name must be Array');angular.forEach(a,function(a){b(a,c)})}function d(a){delete i[a]}function e(a){return angular.isDefined(i[a])}function f(a){return i[a]}function g(){return i}function h(){i={}}var i={};this.definePermission=b,this.defineManyPermissions=c,this.removePermissionDefinition=d,this.hasPermissionDefinition=e,this.getPermissionDefinition=f,this.getStore=g,this.clearStore=h}])}(),function(){"use strict";angular.module("permission").service("RoleStore",["Role",function(a){function b(b,c,d){h[b]=new a(b,c,d)}function c(a){delete h[a]}function d(a){return angular.isDefined(h[a])}function e(a){return h[a]}function f(){return h}function g(){h={}}var h={};this.defineRole=b,this.getRoleDefinition=e,this.hasRoleDefinition=d,this.removeRoleDefinition=c,this.getStore=f,this.clearStore=g}])}(),function(){"use strict";function a(a,b,c,d){return{restrict:"A",scope:!0,bindToController:{only:"=?permissionOnly",except:"=?permissionExcept",onAuthorized:"&?permissionOnAuthorized",onUnauthorized:"&?permissionOnUnauthorized",deprecatedOnly:"=only",deprecatedExcept:"=except"},controllerAs:"permission",controller:["$scope","$element",function(e,f){function g(){angular.isFunction(i.onAuthorized)?i.onAuthorized()(f):d.showElement(f)}function h(){angular.isFunction(i.onUnauthorized)?i.onUnauthorized()(f):d.hideElement(f)}var i=this;(angular.isDefined(i.deprecatedOnly)||angular.isDefined(i.deprecatedExcept))&&a.warn('Attributes "only" and "except" are deprecated since 2.2.0+ and their support will be removed from 2.4.0. Use scoped "permission-only" and "permission-except" instead.'),e.$watchGroup(["permission.only","permission.except","permission.deprecatedOnly","permission.deprecatedExcept"],function(){try{var d=new c({only:i.only||i.deprecatedOnly,except:i.except||i.deprecatedExcept});b.authorize(d).then(function(){g()})["catch"](function(){h()})}catch(e){h(),a.error(e.message)}})}]}}a.$inject=["$log","Authorization","PermissionMap","PermissionStrategies"],angular.module("permission").directive("permission",a)}(),function(){"use strict";angular.module("permission").service("Authorization",["$q","PermissionStore","RoleStore",function(a,b,c){function d(a,b){return n=b,e(a)?f(a):i(a)}function e(a){return!(!angular.isArray(a.only[0])&&!angular.isArray(a.except[0]))}function f(b){var c=a.defer();return g(b,c),c.promise}function g(b,c){var d=l(b.except);a.all(d).then(function(a){c.reject(a)})["catch"](function(){h(b,c)})}function h(b,c){if(!b.only.length)return void c.resolve();var d=l(b.only);a.all(d).then(function(a){c.resolve(a)})["catch"](function(a){c.reject(a)})}function i(b){var c=a.defer();return j(b,c),c.promise}function j(b,c){var d=m(b.except);a.only(d).then(function(a){c.reject(a)})["catch"](function(){k(b,c)})}function k(b,c){if(!b.only.length)return void c.resolve();var d=m(b.only);a.only(d).then(function(a){c.resolve(a)})["catch"](function(a){c.reject(a)})}function l(b){return b.length?b.map(function(b){var c=m(b);return a.only(c)}):[a.reject()]}function m(d){return d.map(function(d){if(c.hasRoleDefinition(d)){var e=c.getRoleDefinition(d);return e.validateRole(n)}if(b.hasPermissionDefinition(d)){var f=b.getPermissionDefinition(d);return f.validatePermission(n)}return a.reject(d)})}this.authorize=d;var n}])}(),function(){"use strict";angular.module("permission").constant("PermissionStrategies",{enableElement:function(a){a.removeAttr("disabled")},disableElement:function(a){a.attr("disabled","disabled")},showElement:function(a){a.removeClass("ng-hide")},hideElement:function(a){a.addClass("ng-hide")}})}();
//# sourceMappingURL=angular-permission.min.js.map